<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_RentacarSaleContract StructType
 * @subpackage Structs
 */
class JP_RentacarSaleContract extends AbstractStructBase
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The Includes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Includes;
    /**
     * The NotIncludes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NotIncludes;
    /**
     * Constructor method for JP_RentacarSaleContract
     * @uses JP_RentacarSaleContract::setName()
     * @uses JP_RentacarSaleContract::setDescription()
     * @uses JP_RentacarSaleContract::setIncludes()
     * @uses JP_RentacarSaleContract::setNotIncludes()
     * @param string $name
     * @param string $description
     * @param string $includes
     * @param string $notIncludes
     */
    public function __construct($name = null, $description = null, $includes = null, $notIncludes = null)
    {
        $this
            ->setName($name)
            ->setDescription($description)
            ->setIncludes($includes)
            ->setNotIncludes($notIncludes);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_RentacarSaleContract
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\JP_RentacarSaleContract
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Includes value
     * @return string|null
     */
    public function getIncludes()
    {
        return $this->Includes;
    }
    /**
     * Set Includes value
     * @param string $includes
     * @return \StructType\JP_RentacarSaleContract
     */
    public function setIncludes($includes = null)
    {
        // validation for constraint: string
        if (!is_null($includes) && !is_string($includes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($includes)), __LINE__);
        }
        $this->Includes = $includes;
        return $this;
    }
    /**
     * Get NotIncludes value
     * @return string|null
     */
    public function getNotIncludes()
    {
        return $this->NotIncludes;
    }
    /**
     * Set NotIncludes value
     * @param string $notIncludes
     * @return \StructType\JP_RentacarSaleContract
     */
    public function setNotIncludes($notIncludes = null)
    {
        // validation for constraint: string
        if (!is_null($notIncludes) && !is_string($notIncludes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($notIncludes)), __LINE__);
        }
        $this->NotIncludes = $notIncludes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_RentacarSaleContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
